;-| 2/3 Button Combination |-----------------------------------------------
[Command]
name = "recovery";Required (do not remove)
command = x+y
time = 1

[Command]
name = "bfg";Required (do not remove)
command = x+a
time = 1

[Command]
name = "bfg";Required (do not remove)
command = b+y
time = 1

[Command]
name = "bfg";Required (do not remove)
command = z+c
time = 1

[Command]
name = "bfg";Required (do not remove)
command = a+b
time = 1

[Command]
name = "bfg";Required (do not remove)
command = a+c
time = 1

[Command]
name = "bfg";Required (do not remove)
command = x+y
time = 1

[Command]
name = "bfg";Required (do not remove)
command = y+z
time = 1

[Command]
name = "bfg";Required (do not remove)
command = ~D, DF, F, D, DF, F, x
time = 20

[Command]
name = "bfg";Required (do not remove)
command = ~D, DF, F, D, DF, F, y
time = 20

[Command]
name = "bfg";Required (do not remove)
command = ~D, DF, F, D, DF, F, z
time = 20

[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

[Command]
name = "c"
command = c
time = 1

[Command]
name = "x"
command = x
time = 1

[Command]
name = "y"
command = y
time = 1

[Command]
name = "z"
command = z
time = 1

[Command]
name = "start"
command = s
time = 1

;-| Hold Dir |--------------------------------------------------------------
[Command]
name = "holdfwd";Required (do not remove)
command = /$F
time = 1

[Command]
name = "holdback";Required (do not remove)
command = /$B
time = 1

[Command]
name = "holdup" ;Required (do not remove)
command = /$U
time = 1

[Command]
name = "holddown";Required (do not remove)
command = /$D
time = 1

;---------------------------------------------------------------------------
; 2. State entry
; --------------
; This is where you define what commands bring you to what states.
;
; Each state entry block looks like:
;   [State -1, Label]           ;Change Label to any name you want to use to
;                               ;identify the state with.
;   type = ChangeState          ;Don't change this
;   value = new_state_number
;   trigger1 = command = command_name
;   . . .  (any additional triggers)
;
; - new_state_number is the number of the state to change to
; - command_name is the name of the command (from the section above)
; - Useful triggers to know:
;   - statetype
;       S, C or A : current state-type of player (stand, crouch, air)
;   - ctrl
;       0 or 1 : 1 if player has control. Unless "interrupting" another
;                move, you'll want ctrl = 1
;   - stateno
;       number of state player is in - useful for "move interrupts"
;   - movecontact
;       0 or 1 : 1 if player's last attack touched the opponent
;                useful for "move interrupts"
;
; Note: The order of state entry is important.
;   State entry with a certain command must come before another state
;   entry with a command that is the subset of the first.
;   For example, command "fwd_a" must be listed before "a", and
;   "fwd_ab" should come before both of the others.
;
; For reference on triggers, see CNS documentation.
;
; Just for your information (skip if you're not interested):
; This part is an extension of the CNS. "State -1" is a special state
; that is executed once every game-tick, regardless of what other state
; you are in.


; Don't remove the following line. It's required by the CMD standard.
[Statedef -1]

;===========================================================================
;This is not a move, but it sets up var(1) to be 1 if conditions are right
;for a combo into a special move (used below).
;Since a lot of special moves rely on the same conditions, this reduces
;redundant logic.
[State -1, Combo condition Reset]
type = VarSet
trigger1 = ishelper
var(13) = 0

[State -1, Combo condition Check]
type = VarSet
triggerall = ishelper
trigger1 = stateno = 0
trigger2 = stateno = 20
var(13) = 1

; For everyone



;===========================================================================

; Turn!
[State -1, Stand Light Punch]
type = ChangeState
value = 100
triggerall = ishelper
triggerall = roundstate = 2
triggerall = backedgedist < -20
triggerall = var(16) = 0
trigger1 = statetype = S
trigger1 = var(13)

;---------------------------------------------------------------------------
; Turn!
[State -1, Stand Light Punch]
type = ChangeState
value = 5
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = statetype = S
trigger1 = var(13)
trigger1 = p2bodydist x < -10

; You lose!
[State -1, Stand Light Punch]
type = ChangeState
value = 170
triggerall = ishelper
triggerall = ctrl || var(13)
triggerall = statetype != A
trigger1 = !(parent, alive)
trigger2 = !alive


; RYou win!
[State -1, Stand Light Punch]
type = ChangeState
value = 180
triggerall = ishelper
trigger1 = statetype = S
trigger1 = stateno = 0
trigger1 = root, stateno = [180,189]



;===========================================================================
;---------------------------------------------------------------------------
; Die!
[State 0, ]
type = VarSet
triggerall = ishelper
trigger1 = alive
trigger1 = var(10) > 0
var(10) = 0
ignorehitpause = 1
[State 0, ]
type = VarAdd
triggerall = ishelper
trigger1 = !alive
trigger1 = var(10) < 6
var(10) = 1
ignorehitpause = 1

[State 5150, 1]
type = parentvaradd
triggerall = ishelper
trigger1 = var(10) = 2
var(30) = 1
ignorehitpause = 1



[State 0, ]
type = ScreenBound
triggerall = ishelper
trigger1 = stateno != [3000,3999]
trigger1 = stateno != [110,119]
value = (movetype=H && stateno != 5150)
;value = (stateno != [110,119])
movecamera = 0,0
ignorehitpause = 1


; Grappler AI

;===========================================================================
;---------------------------------------------------------------------------
; Walk Forward
[State -1, Stand Light Punch]
type = ChangeState
value = 20
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(11) = 1
trigger1 = var(13) = 1
trigger1 = stateno != 20
trigger1 = p2bodydist x >= 6

;---------------------------------------------------------------------------
;Kung Fu Throw
;
[State -1, Kung Fu Throw]
type = ChangeState
value = 800
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(13) = 1
trigger1 = var(11) = 1
trigger1 = p2bodydist X < 6
trigger1 = (p2statetype = S) || (p2statetype = C)
trigger1 = p2movetype != H

; Sniper AI

;---------------------------------------------------------------------------
[State -1, Kung Fu Throw]
type = ChangeState
value = 1000
triggerall = ishelper
triggerall = roundstate = 2
triggerall = numhelper(1000) = 0
trigger1 = var(13) = 1
trigger1 = var(11) = 2
trigger1 = p2bodydist X >= 90
trigger1 = p2stateno != [5100,5150]

; Walk Forward
[State -1, Stand Light Punch]
type = ChangeState
value = 105
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(11) = 2
trigger1 = var(13) = 1
trigger1 = p2bodydist x < 90
trigger1 = backedgedist >= 30

; Walk Forward
[State -1, Stand Light Punch]
type = ChangeState
value = 250
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(11) = 2
trigger1 = var(13) = 1
trigger1 = p2bodydist x < 90
trigger1 = backedgedist < 30

; BASIC->SPECIAL AI

;===========================================================================
;---------------------------------------------------------------------------
; Walk Forward
[State -1, Stand Light Punch]
type = ChangeState
value = 20
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(11) = 3
trigger1 = var(13) = 1
trigger1 = stateno != 20
trigger1 = p2bodydist x >= 40

;---------------------------------------------------------------------------
;Shoryuken
;
[State -1, Kung Fu Throw]
type = ChangeState
value = ifelse(random<500,1100,1200)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = var(11) = 3
triggerall = p2stateno != [5100,5150]
trigger1 = stateno = 200
trigger1 = animtime = 0
trigger1 = movecontact
trigger2 = stateno = 230
trigger2 = animtime = 0
trigger2 = movecontact
trigger3 = stateno = 210
trigger3 = time >= 8
trigger3 = movecontact
trigger4 = stateno = 240
trigger4 = time >= 12
trigger4 = movecontact

;---------------------------------------------------------------------------
;Kung Fu Throw
;
[State -1, Kung Fu Throw]
type = ChangeState
value = ifelse(random<500,230,200) + ifelse(random<500,10,0)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(13) = 1
trigger1 = var(11) = 3
trigger1 = p2bodydist X = [0,40]

; COMBO AI

;===========================================================================
;---------------------------------------------------------------------------
; Walk Forward
[State -1, Stand Light Punch]
type = ChangeState
value = 20
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(11) = 4
trigger1 = var(13) = 1
trigger1 = stateno != 20
trigger1 = p2bodydist x >= 14

[State -1, Combo]
type = ChangeState
value = 200
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(13) = 1
trigger1 = var(11) = 4
trigger1 = p2bodydist X = [0,14]

[State -1, Combo]
type = ChangeState
value = 230
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(11) = 4
trigger1 = stateno = 200
trigger1 = animtime = 0
trigger1 = movecontact

[State -1, Combo]
type = ChangeState
value = 210
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(11) = 4
trigger1 = stateno = 230
trigger1 = time >= 6
trigger1 = movecontact

[State -1, Combo]
type = ChangeState
value = 240
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(11) = 4
trigger1 = stateno = 210
trigger1 = movecontact

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,220,250)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(11) = 4
trigger1 = stateno = 240
trigger1 = movecontact

; JUMPER AI

;===========================================================================
;---------------------------------------------------------------------------

; away
[State -1, Stand Light Punch]
type = ChangeState
value = 105
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(11) = 5
trigger1 = var(13) = 1
trigger1 = stateno != 20
trigger1 = p2bodydist x = [-5,9]

; Walk Forward
[State -1, Stand Light Punch]
type = ChangeState
value = 41
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = var(11) = 5
trigger1 = var(13) = 1
trigger1 = stateno != 20
trigger1 = p2bodydist x >= 10

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,610,640)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
trigger1 = stateno = 50
trigger1 = var(11) = 5 || var(11) = 6
trigger1 = p2bodydist X = [-8,50]
trigger1 = p2statetype = A || animelem = 7


;===========================================================================

; SMART AI

;---------------------------------------------------------------------------
;Kung Fu Throw
;
[State -1, Kung Fu Throw]
type = ChangeState
value = 800
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(13) = 1
trigger1 = var(11) = 6
trigger1 = p2bodydist X < 6
trigger1 = (p2statetype = S) || (p2statetype = C)
trigger1 = p2movetype != H

[State -1, Combo]
type = ChangeState
value = 3000
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno = [120,169]
triggerall = var(11) = 6
triggerall = power >= 1000
triggerall = p2movetype != A || facing = enemynear, facing
triggerall = random < 500
trigger1 = var(13) = 1 || stateno = 11

[State -1, Combo]
type = ChangeState
value = 1100
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X <= 60
triggerall = enemynear , statetype = A
triggerall = enemynear , vel x >= 0
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1

[State -1, Combo]
type = ChangeState
value = 3100
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [-5,88]
triggerall = p2movetype != A || facing = enemynear, facing
triggerall = random < 200
triggerall = power >= 1000
trigger1 = var(13) = 1
trigger1 = random < 50
trigger2 = stateno = [200,299]
trigger2 = movehit

[State -1, Stand Light Punch]
type = ChangeState
value = 10
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2movetype != A || facing = enemynear, facing
triggerall = statetype = S
triggerall = var(13)
triggerall = var(11) = 6
trigger1 = p2statetype = C
trigger2 = p2statetype = S
trigger2 = p2stateno = [120,169]

[State -1, Stand Light Punch]
type = ChangeState
value = 12
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2statetype != C
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = statetype = C
trigger1 = stateno = 11
trigger1 = var(11) = 6
trigger1 = p2statetype != S || p2stateno != [120,169]

[State -3: ChangeState]
type = ChangeState
triggerall = ishelper
triggerall = (Var(11) = 6) && (StateType = S) && (var(13)) && (EnemyNear, Facing != Facing)
trigger1 = (P2MoveType = A) || (EnemyNear, NumProj > 0)
value = 130

[State -3: ChangeState]
type = ChangeState
triggerall = ishelper
triggerall = (Var(11) = 6) && (StateType = C) && (stateno = 11) && (EnemyNear, Facing != Facing)
trigger1 = (P2MoveType = A) || (EnemyNear, NumProj > 0)
value = 131

[State -1, Stand Light Punch]
type = ChangeState
value = 105
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = statetype = S
trigger1 = var(13)
trigger1 = var(11) = 6
trigger1 = p2bodydist x = [30,50]
trigger1 = p2movetype = A
trigger1 = random < 100
trigger1 = backedgedist > 60

[State -1, Combo]
type = ChangeState
value = 200 + ifelse(statetype=C,200,0)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [0,50]
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1 || stateno = 11

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,210,230) + ifelse(statetype=C,200,0)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [5,75]
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1 || stateno = 11
trigger1 = random < 100
trigger2 = stateno = 200 + ifelse(statetype=C,200,0)
trigger2 = movehit

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,210,240) + ifelse(statetype=C,200,0)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [5,75]
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1 || stateno = 11
trigger1 = random < 90
trigger2 = stateno = 230 + ifelse(statetype=C,200,0)
trigger2 = movehit
trigger2 = time >= 8

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,220,240) + ifelse(statetype=C,200,0)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [5,80]
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1 || stateno = 11
trigger1 = random < 80
trigger2 = stateno = 210 + ifelse(statetype=C,200,0)
trigger2 = movehit
trigger2 = time >= 10

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,3100,250)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [5,82]
triggerall = p2movetype != A || facing = enemynear, facing
triggerall = random < 500
triggerall = power >= 1000
trigger1 = var(13) = 1 || stateno = 11
trigger1 = random < 70
trigger2 = stateno = 240 + ifelse(statetype=C,200,0)
trigger2 = movehit
trigger2 = time >= 13

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,220,250) + ifelse(statetype=C,200,0)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [5,82]
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1 || stateno = 11
trigger1 = random < 70
trigger2 = stateno = 240 + ifelse(statetype=C,200,0)
trigger2 = movehit
trigger2 = time >= 13

[State -1, Combo]
type = ChangeState
value = ifelse(random<500,1100,1200)
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2stateno != [5100,5150]
triggerall = var(11) = 6
triggerall = p2bodydist X = [-5,110]
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1
trigger1 = random < 50
trigger2 = stateno = 220 || stateno = 250
trigger2 = movehit


;---------------------------------------------------------------------------
[State -1, Kung Fu Throw]
type = ChangeState
value = 1000
triggerall = ishelper
triggerall = roundstate = 2
triggerall = numhelper(1000) = 0
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = var(13) = 1
trigger1 = var(11) = 6
trigger1 = p2bodydist X >= 90
trigger1 = p2stateno != [5100,5150]
trigger1 = random < 100

[State -1, Stand Light Punch]
type = ChangeState
value = ifelse(random<100,100, ifelse(random<500,20,41) )
triggerall = ishelper
triggerall = roundstate = 2
triggerall = p2movetype != A || facing = enemynear, facing
trigger1 = statetype = S
trigger1 = var(13) && stateno != 20
trigger1 = var(11) = 6
trigger1 = p2bodydist x >= 45

;===========================================================================

; BFG AI

[State 0, ]
type = ParentVarSet
trigger1 = backedgedist < -30
trigger1 = ishelper
trigger1 = stateno = 105
trigger1 = var(11) = 7
v = 35
value = 0

[State 0, ]
type = ParentVarSet
trigger1 = !alive;var(10) >= root, var(41)
trigger1 = var(11) = 7
v = 35
value = 0

[State -1, Kung Fu Throw]
type = ChangeState
value = 3900
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(13) = 1
trigger1 = var(11) = 7
trigger1 = var(16) = 0
trigger1 = p2stateno != [5100,5150]

[State -1, Kung Fu Throw]
type = ChangeState
value = 105
triggerall = ishelper
triggerall = roundstate = 2
trigger1 = var(13) = 1
trigger1 = var(11) = 7
trigger1 = var(16) = 1

[State -1, Kung Fu Throw]
type = DestroySelf
trigger1 = backedgedist < -30
trigger1 = ishelper
trigger1 = stateno = 105
trigger1 = var(11) = 7

[State 0, ]
type = PlaySnd
trigger1 = alive
trigger1 = time = 1
trigger1 = stateno = 5000 || stateno = 5010 || stateno = 5030 || stateno = 5040
trigger1 = random < 500
value = 5000,ifelse(random<500,0,1) + ifelse(random<500,0,1)
channel = 0


